﻿// sem2_lab1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#define MAX_STR_LNG 80
#define PREFIX 4
using namespace std;

int main()
{
    int number_count;
    int bin_count;
    //Ввод данных
    cerr << "Enter number count: ";
    cin >> number_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;
    vector<double> numbers(number_count);
    vector<int> bins(bin_count); 
    for (int i = 0; i < number_count; i++)
    {
        cin >> numbers[i];
    }
    //Находим минимальное и максимальное значение
    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
    //Вычисляем гистограмму
    double bin_size = (max - min) / bin_count;
    for (int i = 0; i < number_count; i++)
    {
        bool found = false;
        for (int j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }

        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    //Находим максимум значений корзин
    int max_count = bins[0];
    for (int x : bins) 
    {
        if (x > max_count) max_count = x;
    }
    //Определяем надо ли масштабировать данные
    int K;
    if (max_count <= (MAX_STR_LNG - PREFIX))
    {
        K = 0;
    }
    else
    {
        K = 1;
    }
    //K = 0; // принудительное отключение масштабирования для 1 и 2
    //Строим гистограмму
    int cnt;
    for (int i = 0; i < bin_count; i++)
    {
        cout.width(3);
        cout.fill(' '); 
        cout << bins[i] << "|";
        if (K == 0)
            cnt = bins[i];
        else
            cnt = bins[i] * (MAX_STR_LNG - PREFIX) / max_count;

        for (double j = 0; j < cnt; j++) {
            cout << "*";
        }
        cout << endl;
    }
}


// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
